
local sui, cfg, suf, smu = SkyUI, SkyUI.Config, SkyUI.Config.UnitFrames, SkyUI.Modules.UnitFrames
local _SavePending, _Save, evt = false, {}, nil

local function round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end

local mnuitems = {}

local function SaveValues(c)
 if c then _Save[c.name] = true end
 if InCombatLockdown() then _SavePending = true return true end

 if _Save["cHud"] then if mnuitems.cHud:GetChecked() then smu.Disable() else smu.Enable() end end
-- if _Save["cActionBars"] then if mnuitems.cActionBars:GetChecked() then SkyUI.Modules.ActionBars.Disable() else SkyUI.Modules.ActionBars.Enable() end end
 
 if _Save["cFocus"] then suf.focus.Enabled = mnuitems.cFocus:GetChecked() end
 if _Save["cPet"] then suf.playerpet.Enabled = mnuitems.cPet:GetChecked() end
 if _Save["cPetTarget"] then suf.playerpettarget.Enabled = mnuitems.cPetTarget:GetChecked() end
 if _Save["cTargetTarget"] then suf.targettarget.Enabled = mnuitems.cTargetTarget:GetChecked() end
 if _Save["cTargetPet"] then suf.targetpet.Enabled = mnuitems.cTargetPet:GetChecked() end
 if _Save["cTargetPetTarget"] then suf.targetpettarget.Enabled = mnuitems.cTargetPetTarget:GetChecked() end

 if _Save["HorzOffset"] then suf.UI.OffsetX = round(mnuitems.HorzOffset:GetValue()) end
 if _Save["VertOffset"] then suf.UI.OffsetY = round(mnuitems.VertOffset:GetValue()) end


 if _Save["cAuras"] then if mnuitems.cAuras:GetChecked() then smu.Auras.Disable() else smu.Auras.Enable() end end

 if _Save["cSwap"] then suf.Auras.Swap = mnuitems.cSwap:GetChecked() end
 if _Save["cCDBD"] then suf.Auras.CooldownBackdrop = not mnuitems.cCDBD:GetChecked() end

 if _Save["cBuffs"] then suf.Auras.Buffs.Enabled = not mnuitems.cBuffs:GetChecked() end
 if _Save["cBuffBar"] then suf.Auras.Buffs.Bars = mnuitems.cBuffBar:GetChecked() end
 if _Save["cBuffName"] then suf.Auras.Buffs.Names = mnuitems.cBuffName:GetChecked() end
 if _Save["cBuffCD"] then suf.Auras.Buffs.CD = mnuitems.cBuffCD:GetChecked() end

 if _Save["cDebuffs"] then suf.Auras.Debuffs.Enabled = not mnuitems.cDebuffs:GetChecked() end
 if _Save["cDebuffBar"] then suf.Auras.Debuffs.Bars = mnuitems.cDebuffBar:GetChecked() end
 if _Save["cDebuffName"] then suf.Auras.Debuffs.Names = mnuitems.cDebuffName:GetChecked() end
 if _Save["cDebuffCD"] then suf.Auras.Debuffs.CD = mnuitems.cDebuffCD:GetChecked() end

 if _Save["MaxBuffBars"] then suf.Auras.Buffs.Max = mnuitems.MaxBuffBars:GetValue() end
 if _Save["MaxBuffBars"] then suf.Auras.Debuffs.Max = mnuitems.MaxDebuffBars:GetValue() end

 if _Save["cRange"] then suf.RangeTransparency = mnuitems.cRange:GetChecked() end

 sui.Modules.Main:OnConfigUpdated()
 _SavePending = false
 _Save = {}
end


local function PlaceBG(mnu, rf, w, h, name, clr, pad)

 local bg = mnu:CreateTexture("cfg" .. name .. "bg", "BACKGROUND")
 bg:ClearAllPoints()
 bg:SetSize(w, h)
 bg:SetPoint("TOPLEFT", rf, "TOPLEFT", 1 + pad.x, -3 + pad.y)
 bg:SetTexture(clr.r, clr.g, clr.b, clr.a)

end

local function PlaceCheckBox(mnu, x, y, rt, name, txt)
 local f = CreateFrame("CheckButton", "cfg" .. name, mnu, "UICheckButtonTemplate")
 mnuitems[name] = f
 f.name = name
 f:ClearAllPoints()

--*TOPLEFT  *TOP  *TOPRIGHT
--LEFT    CENTER   RIGHT
--*BTMLEFT  *BTM  *BTMRIGHT

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 55 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 25 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 25 end
 f:SetPoint(rt, x, y)
 
 f:SetSize(25, 25)
 _G["cfg" .. name .. "Text"]:SetText(" " .. txt)

 local fnt = SkyUI.Strings.Header
 _G["cfg" .. name .. "Text"]:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 _G["cfg" .. name .. "Text"]:SetTextColor(1, 1, 1, 1)
-- _G["cfg" .. name .. "Text"]:SetFontObject(GameFontNormal)
 _G["cfg" .. name .. "Text"]:SetPoint("LEFT", 23, 1)
-- MakeMovable(frame)
 f:SetScript("OnClick", SaveValues)
 
 
-- (point, relativeFrame, relativePoint, ofsx, ofsy);
-- PlaceBG(mnu, f, 200, 18, name, {r = 0.1, g = 0.1, b = 0.1, a = 0}, {x = 0, y = 0})
 
end


local function Slider_ValueChanged(this)
 mnuitems[this._EditBox]:SetText(round(this:GetValue()))
 SaveValues(this)
end

local function PlaceSlider(mnu, x, y, rt, w, name, txt, min, max, val, default, editbox)

 local f = CreateFrame("Slider", "cfg" .. name, mnu, "OptionsSliderTemplate")

 mnuitems[name] = f
 f.name = name

 if not val then val = default end

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 f:SetPoint(rt, x, y)

 f:SetSize(w, 15)
 f:SetOrientation("HORIZONTAL")
 
 f._EditBox = editbox
 
 f:SetMinMaxValues(min, max);
 f:SetValueStep(1);
 f.DefaultValue = default
 f:SetValue(val)
 
 _G["cfg" .. name .. "Low"]:SetText(min)
 _G["cfg" .. name .. "High"]:SetText(max)
 _G["cfg" .. name .. "Text"]:SetText(txt)

 local fnt = SkyUI.Strings.Header
 _G["cfg" .. name .. "Text"]:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 _G["cfg" .. name .. "Text"]:SetTextColor(1, 1, 1, 1)

 f:SetScript("OnValueChanged", Slider_ValueChanged)

end

local function EditBox_EnterPressed(this)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText())
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
 this:ClearFocus()
end

local function EditBox_MouseWheel(this, delta)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText()) + delta
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
end


local function EditBox_FocusLost(this)
 SaveValues(this)
end


local function PlaceText(mnu, x, y, rt, name, txt, slider)
 local f = CreateFrame("EditBox", "cfg" .. name, mnu, "InputBoxTemplate")
 mnuitems[name] = f
 f.name = name

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end

 f:SetPoint(rt, x, y)
 f:SetParent(mnu)
 
 f:SetSize(40, 22)
 f:SetTextInsets(0,4,7,5)
 f._Slider = slider
 
 f:SetText(txt)

 f:SetFontObject(GameFontHighlight)
 f:SetJustifyH("CENTER")
 
 f:SetMaxLetters(5)
 
 f:SetAutoFocus(false)
 
 f:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)
 f:SetScript("OnEnterPressed", EditBox_EnterPressed)
 f:SetScript("OnMouseWheel", EditBox_MouseWheel)
 f:SetScript("OnEditFocusLost", EditBox_FocusLost)
end



local function PlaceString(mnu, x, y, rt, name, txt, fnt)
 
 local str = mnu:CreateFontString("cfg" .. name)
 
 mnuitems[name] = str
 str.name = name
 str:ClearAllPoints()

 str:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 str:SetPoint(rt, x, y)
 str:SetJustifyH("LEFT")
 str:SetText(txt)
 --:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a)
 return str
end

local function PlaceHeader(mnu, x, y, rt, w, name, txt)
 x = x + 8
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 str = PlaceString(mnu, x, y, rt, name, txt, SkyUI.Strings.Header)
 
 PlaceBG(mnu, str, w, 20, name, {r = 0.15, g = 0.15, b = .15, a = 1}, {x = -4, y = 7})
end

local function OnEventCB(self, evt, ...)
 if evt == "PLAYER_REGEN_ENABLED" then if _SavePending then SaveValues() end
 elseif evt == "PLAYER_REGEN_DISABLED" then SkyUIConfigMenu:Hide() end
end

function ConfigMenu_Loaded()
 if not evt then evt = CreateFrame("Frame")
  SkyUIConfigMenu:HookScript("OnShow",
   function(self)
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    if not InCombatLockdown() and _SavePending then SaveValues() end
   end)
  SkyUIConfigMenu:HookScript("OnHide", function(self) self:UnregisterEvent("PLAYER_REGEN_DISABLED") self:UnregisterEvent("PLAYER_REGEN_ENABLED") end)
  SkyUIConfigMenu:SetScript("OnEvent", OnEventCB)
 end

 local mnu = SkyUIConfigMenu

 -- Tab 1
 PlaceCheckBox(cfgTab1, 0, 10, "TOPLEFT", "cHud", "Disable SkyUI")

 PlaceSlider(cfgTab1, 0, 60, "TOP", 450, "HorzOffset", "Horizontal Position", -400, 50, SkyUI.Config.UnitFrames.OffsetX, 0, "HorzOffsetVal")
 PlaceSlider(cfgTab1, 0, 140, "TOP", 450, "VertOffset", "Vertical Position", -300, 500, SkyUI.Config.UnitFrames.OffsetY, 0, "VertOffsetVal")

 PlaceText(cfgTab1, 0, 85, "TOP", "HorzOffsetVal", "0", "HorzOffset")
 PlaceText(cfgTab1, 0, 165, "TOP", "VertOffsetVal", "0", "VertOffset")

 PlaceHeader(cfgTab1, 0, 75, "BOTTOMLEFT", 210, "PlayerFrames", "Player")
 PlaceHeader(cfgTab1, 235, 75, "BOTTOMLEFT", 210, "TargetFrames", "Target")

 PlaceCheckBox(cfgTab1, 0, 40, "BOTTOMLEFT", "cFocus", "Focus")
 PlaceCheckBox(cfgTab1, 0, 20, "BOTTOMLEFT", "cPet", "Pet")
 PlaceCheckBox(cfgTab1, 0, 0, "BOTTOMLEFT", "cPetTarget", "Pet's Target")

 PlaceCheckBox(cfgTab1, 235, 40, "BOTTOMLEFT", "cTargetTarget", "Target")
 PlaceCheckBox(cfgTab1, 235, 20, "BOTTOMLEFT", "cTargetPet", "Pet")
 PlaceCheckBox(cfgTab1, 235, 0, "BOTTOMLEFT", "cTargetPetTarget", "Pet's Target") 
 
 -- Tab 2 (Used to be for actionbars)

 -- Tab 3
 PlaceCheckBox(cfgTab3, 0, 10, "TOPLEFT", "cAuras", "Disable Auras")
 PlaceCheckBox(cfgTab3, 235, 10, "TOPLEFT", "cSwap", "Swap Aura Positions")
 PlaceCheckBox(cfgTab3, 235, 30, "TOPLEFT", "cCDBD", "Disable Cooldown Backdrop")

 PlaceHeader(cfgTab3, 0, 60, "TOPLEFT", 210, "PlayerFrames", "Buffs")
 PlaceHeader(cfgTab3, 235, 60, "TOPLEFT", 210, "TargetFrames", "Debuffs")

 PlaceCheckBox(cfgTab3, 0, 100, "TOPLEFT", "cBuffs", "Disable")
 PlaceCheckBox(cfgTab3, 0, 130, "TOPLEFT", "cBuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 0, 150, "TOPLEFT", "cBuffName", "Names")
 PlaceCheckBox(cfgTab3, 0, 170, "TOPLEFT", "cBuffCD", "Countdowns")

 PlaceCheckBox(cfgTab3, 235, 100, "TOPLEFT", "cDebuffs", "Disable")
 PlaceCheckBox(cfgTab3, 235, 130, "TOPLEFT", "cDebuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 235, 150, "TOPLEFT", "cDebuffName", "Names")
 PlaceCheckBox(cfgTab3, 235, 170, "TOPLEFT", "cDebuffCD", "Countdowns")

 PlaceSlider(cfgTab3, 10, 250, "TOPLEFT", 200, "MaxBuffBars", "Max Buff Bars", 0, 12, SkyUI.Config.UnitFrames.Auras.Buffs.Max, 8, "MaxBuffBarsVal")
 PlaceSlider(cfgTab3, 245, 250, "TOPLEFT", 200, "MaxDebuffBars", "Max Debuff Bars", 0, 12, SkyUI.Config.UnitFrames.Auras.Debuffs.Max, 8, "MaxDebuffBarsVal")

 PlaceText(cfgTab3, 95, 265, "TOPLEFT", "MaxBuffBarsVal", "8", "MaxBuffBars")
 PlaceText(cfgTab3, 325, 265, "TOPLEFT", "MaxDebuffBarsVal", "8", "MaxDebuffBars")

 -- Tab 4
 PlaceCheckBox(cfgTab4, 0, 10, "TOPLEFT", "cRange", "Range Transparency")

 
end

SkyUI.OnConfigLoaded = function ()
 if InCombatLockdown() then return true end
 local cfg = SkyUI.Config
 
 mnuitems.cHud:SetChecked(not cfg.UnitFrames.UI.Enabled)

 mnuitems.cFocus:SetChecked(cfg.UnitFrames.focus.Enabled)
 mnuitems.cPet:SetChecked(cfg.UnitFrames.playerpet.Enabled)
 mnuitems.cPetTarget:SetChecked(cfg.UnitFrames.playerpettarget.Enabled)
 mnuitems.cTargetTarget:SetChecked(cfg.UnitFrames.targettarget.Enabled)
 mnuitems.cTargetPet:SetChecked(cfg.UnitFrames.targetpet.Enabled)
 mnuitems.cTargetPetTarget:SetChecked(cfg.UnitFrames.targetpettarget.Enabled)

 mnuitems.HorzOffset:SetValue(cfg.UnitFrames.UI.OffsetX)
 mnuitems.HorzOffsetVal:SetText(cfg.UnitFrames.UI.OffsetX)

 mnuitems.VertOffset:SetValue(cfg.UnitFrames.UI.OffsetY)
 mnuitems.VertOffsetVal:SetText(cfg.UnitFrames.UI.OffsetY)



 mnuitems.cAuras:SetChecked(not cfg.UnitFrames.Auras.Enabled)
 mnuitems.cSwap:SetChecked(cfg.UnitFrames.Auras.Swap)
 mnuitems.cCDBD:SetChecked(not cfg.UnitFrames.Auras.CooldownBackdrop)
 

 mnuitems.cBuffs:SetChecked(not cfg.UnitFrames.Auras.Buffs.Enabled)
 mnuitems.cBuffBar:SetChecked(cfg.UnitFrames.Auras.Buffs.Bars)
 mnuitems.cBuffName:SetChecked(cfg.UnitFrames.Auras.Buffs.Names)
 mnuitems.cBuffCD:SetChecked(cfg.UnitFrames.Auras.Buffs.CD)

 mnuitems.cDebuffs:SetChecked(not cfg.UnitFrames.Auras.Debuffs.Enabled)
 mnuitems.cDebuffBar:SetChecked(cfg.UnitFrames.Auras.Debuffs.Bars)
 mnuitems.cDebuffName:SetChecked(cfg.UnitFrames.Auras.Debuffs.Names)
 mnuitems.cDebuffCD:SetChecked(cfg.UnitFrames.Auras.Debuffs.CD)

 mnuitems.MaxBuffBars:SetValue(cfg.UnitFrames.Auras.Buffs.Max)
 mnuitems.MaxBuffBarsVal:SetText(cfg.UnitFrames.Auras.Buffs.Max)

 mnuitems.MaxDebuffBars:SetValue(cfg.UnitFrames.Auras.Debuffs.Max)
 mnuitems.MaxDebuffBarsVal:SetText(cfg.UnitFrames.Auras.Debuffs.Max)


 mnuitems.cRange:SetChecked(cfg.UnitFrames.RangeTransparency)

 
 sui.Modules.Main:OnConfigUpdated()
end

SLASH_SKYUI1 = "/skyui"
SlashCmdList["SKYUI"] = function(msg, editBox) SkyUIConfigMenu:Show() end

SLASH_SKY1 = "/sky"
SlashCmdList["SKY"] = function(msg, editBox) SkyUIConfigMenu:Show() end











